
-----
-- DO token filter                                  Copyright (c) 2006 Asko Kauppi
--
-- Allows use of "do .. end" as shorthand for "function() .. end". Useful in callback
-- tables, switch cases, etc.
--
-- Usage:
--      lua -lftools -fdo ...
--
-- Requires:    Lua 5.1, with token filter patch applied
--              ftools.lua
-----

if type( rawget(_G,"FILTER") )~="table" then
    error "Requires ftools.lua to be loaded"
end

local cue= { ['=']=1, [',']=1, ['{']=1, ['(']=1 }

-- sugar "'='|','|'{'|'(' do" -> "? function ()"
--
local function DO(p)
    local tk
    while not cue[ p:read() ] do end      -- find next
    repeat tk= p:read() until not cue[tk]  -- handle "{{", "={" etc. 
    if tk=="do" then
        p:replace( 1, "function", '(', ')' )
	end
end

FILTER.link( DO )
