
-----
-- ? cond { true_choice, false_choice } token filter
--
-- Expects the _G["?"] function to be defined, to do the heavy (not so) work.
--
-- Eases the syntax a bit, and removes requirement to have braces around
-- the condition (they're still allowed, of course).
--
-- Note on using tables in condition:
--
--      ? f{some}{a,b}     -- 'f' taken to be condition, {some[,nil]} the values
--      ? (f{some}) {a,b}   -- ok
--      ? f({some}) {a,b}   -- ok
-----

if type( rawget(_G,"FILTER") )~="table" then
    error "requires ftools.lua to be loaded"
end

-- TBD: does not allow '{}' in the condition; we could add paranthesis counting
--      so that can be done IN CASE "? (f{some}) {" is used (paranthesis around the
--      condition.

-------
-- sugar "? cond { ..." -> "_G['?'] (cond) { ..."
--
local function TRICOND(p)
    p["until"](p,"?")      -- p:until "?"
    p:replace( 1, "<name>","?", '(' );
    while true do
        local tk2= p:read()
        if tk2=='?' then
            error "Wrapping ? not allowed!"
        elseif tk2=='{' then
            p:replace( 1, ')','{' )
            break
        else
            p:flush()
        end
    end
end
FILTER.link( TRICOND )



-- sugar "? cond {..." -> "tr(cond) { ..."
--

--[[
local function TRI(get,put)
	put("TRI init")
	while true do
		local l1,t1,v1=get()
        if t1=='?' then
            put(l1,"<name>","tf")
            put(l1,"(")
            while true do
                local l2,t2,v2=get()
                if t2=='?' then
                    error "Wrapping ? not implemented!"
                elseif t2=='{' then
                    put(l2,")")
                    put(l2,t2)
                    break
                end
                put(l2,t2,v2)
            end
        else
            put(l1,t1,v1)
		end
	end
end

function FILTER(get,source)
	FILTER=coroutine.wrap(TRI)
	FILTER(get,coroutine.yield)
end
]]--
