--
-- TEST-SELECT.LUA
--

local function a(...)
    assert( #... == select('#',...) )

    for k=1,#... do
        print( k, ...[k] )
        assert( ...[k] == (select(k,...)) )
    end
    
    print( #... )
    print( ...[-1] )        -- last

    -- Using '#...' within the index should not be needed (since negative values give
    -- last, last-n values) but just so it CAN be done:
    --
    assert( ...[#...] == ...[-1] )

    print( ...[#...] )      -- last: (select(select('#',...),...))
    print( ...[#...+1] )    -- nil
    
    -- Working with []
    --
    local t= {3,2,1}
    print( ...[t[3]] )
    assert( ...[t[3]] == select(1,...) )
end

a( "moon", "mån", "kuu" )

--output:
--1       moon
--2       mån
--3       kuu
--3
--kuu
--kuu
--nil
--moon
